Page MenuHomePhabricator

[ThinLTO] Restructure AliasSummary to contain ValueInfo of Aliasee
ClosedPublic

Authored by tejohnson on Jan 30 2019, 1:43 PM.

Details

Summary

The AliasSummary previously contained the AliaseeGUID, which was only
populated when reading the summary from bitcode. This patch changes it
to instead hold the ValueInfo of the aliasee, and always populates it.
This enables more efficient access to the ValueInfo (specifically in the
recent patch r352438 which needed to perform an index hash table lookup
using the aliasee GUID).

As noted in the comments in AliasSummary, we no longer technically need
to keep a pointer to the corresponding aliasee summary, since it could
be obtained by walking the list of summaries on the ValueInfo looking
for the summary in the same module. However, I am concerned that this
would be inefficient when walking through the index during the thin
link for various analyses. That can be reevaluated in the future.

By always populating this new field, we can remove the guard and special
handling for a 0 aliasee GUID when dumping the dot graph of the summary.

An additional improvement in this patch is when reading the summaries
from LLVM assembly we now set the AliaseeSummary field to the aliasee
summary in that same module, which makes it consistent with the behavior
when reading the summary from bitcode.

Diff Detail

Repository
rL LLVM

Event Timeline

tejohnson created this revision.Jan 30 2019, 1:43 PM
Herald added a project: Restricted Project. · View Herald TranscriptFeb 8 2019, 6:32 AM
evgeny777 accepted this revision.Mar 14 2019, 4:14 AM

This should be rebased against r354850. Otherwise LGTM.

This revision is now accepted and ready to land.Mar 14 2019, 4:14 AM
tejohnson retitled this revision from [ThinLTO] Restructor AliasSummary to contain ValueInfo of Aliasee to [ThinLTO] Restructure AliasSummary to contain ValueInfo of Aliasee.Mar 15 2019, 8:10 AM
This revision was automatically updated to reflect the committed changes.